VERSION 2.00
Begin Form Form1 
   Caption         =   "VBFRACTAL"
   ClientHeight    =   4710
   ClientLeft      =   1110
   ClientTop       =   2100
   ClientWidth     =   7200
   Height          =   5115
   Left            =   1050
   LinkTopic       =   "Form1"
   ScaleHeight     =   4710
   ScaleWidth      =   7200
   Top             =   1755
   Width           =   7320
   Begin SSCommand Command3D7 
      Caption         =   "E x i t"
      Font3D          =   3  'Inset w/light shading
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   425
      Left            =   4695
      TabIndex        =   8
      Top             =   3780
      Width           =   2200
   End
   Begin SSCommand Julia256Button 
      Caption         =   "Julia 256"
      Font3D          =   3  'Inset w/light shading
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   425
      Left            =   4695
      TabIndex        =   7
      Top             =   3060
      Width           =   2200
   End
   Begin SSCommand Julia16Button 
      Caption         =   "Julia 16"
      Font3D          =   3  'Inset w/light shading
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   425
      Left            =   4695
      TabIndex        =   6
      Top             =   2565
      Width           =   2200
   End
   Begin SSCommand JuliaBWButton 
      Caption         =   "Julia B/W"
      Font3D          =   3  'Inset w/light shading
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   425
      Left            =   4695
      TabIndex        =   5
      Top             =   2085
      Width           =   2200
   End
   Begin SSCommand Mandel256Button 
      Caption         =   "Mandelbrot 256"
      Font3D          =   3  'Inset w/light shading
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   425
      Left            =   4680
      TabIndex        =   4
      Top             =   1350
      Width           =   2200
   End
   Begin SSCommand Mandel16Button 
      Caption         =   "Mandelbrot 16"
      Font3D          =   3  'Inset w/light shading
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   425
      Left            =   4680
      TabIndex        =   3
      Top             =   855
      Width           =   2200
   End
   Begin SSCommand MandelBWButton 
      Caption         =   "Mandelbrot B/W"
      Font3D          =   3  'Inset w/light shading
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   425
      Left            =   4680
      TabIndex        =   2
      Top             =   375
      Width           =   2200
   End
   Begin SSPanel Panel3D1 
      BackColor       =   &H00C0C0C0&
      BevelInner      =   1  'Inset
      Font3D          =   0  'None
      Height          =   4155
      Left            =   240
      TabIndex        =   0
      Top             =   255
      Width           =   4155
      Begin PictureBox Picture1 
         Height          =   3870
         Left            =   150
         ScaleHeight     =   256
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   256
         TabIndex        =   1
         Top             =   150
         Width           =   3870
      End
   End
End

Sub Command3D7_Click ()

    End

End Sub

Sub Form_Load ()

    ChDir App.Path
    STOPNOW = False

End Sub

Sub Julia16Button_Click ()
Dim X As Double, Y As Double
Dim cx As Double, cy As Double
Dim MaxIter As Integer, Color As Integer
Dim xmin As Double, ymin As Double, xmax As Double, ymax As Double

STOPNOW = False
' The value of the c parameter
cx = -.74543
cy = .11301
' Center square around (cx, cy) value
xmin = -1.5 - cx
xmax = 1.5 - cx
ymin = -1.5 - cy
ymax = 1.5 - cy

nx = 256
ny = 256

Picture1.Cls

MaxIter = 128
For iy = 0 To ny - 1
    Y = ymin + iy * (ymax - ymin) / (ny - 1)
    For ix = 0 To nx - 1
        If STOPNOW Then Exit Sub
        X = xmin + ix * (xmax - xmin) / (nx - 1)
        Color = VBJulia(cx, cy, X, Y, MaxIter)
        Picture1.PSet (ix, iy), QBColor(Color Mod 16)
    Next
    DoEvents
Next
STOPNOW = True

End Sub

Sub Julia256Button_Click ()
Dim X As Double, Y As Double
Dim cx As Double, cy As Double
Dim Color As Integer, CIndex As Integer
Dim MaxIter As Integer
Dim xmin As Double, ymin As Double, xmax As Double, ymax As Double

STOPNOW = False
i% = LoadPalette()
If i% < 0 Then Exit Sub

' The value of the c parameter
cx = -.74543
cy = .11301
' Center square around (cx, cy) value
xmin = -1.5 - cx
xmax = 1.5 - cx
ymin = -1.5 - cy
ymax = 1.5 - cy

nx = 256
ny = 256

MaxIter = 256
For iy = 0 To ny - 1
    Y = ymin + iy * (ymax - ymin) / (ny - 1)
    For ix = 0 To nx - 1
        If STOPNOW Then Exit Sub
        X = xmin + ix * (xmax - xmin) / (nx - 1)
        Color = VBJulia(cx, cy, X, Y, MaxIter)
        CIndex = Color Mod 256
        Picture1.PSet (ix, iy), RGB(Palette(CIndex, 1), Palette(CIndex, 2), Palette(CIndex, 3))
    Next
    DoEvents
Next
STOPNOW = True

End Sub

Sub JuliaBWButton_Click ()

Dim X As Double, Y As Double
Dim cx As Double, cy As Double
Dim MaxIter As Integer
Dim ix As Integer, iy As Integer
Dim nx As Integer, ny As Integer

STOPNOW = False
nx = 256
ny = 256
Rem The value of the c parameter
cx = -.74543
cy = .11301
Rem Center square around (cx, cy) value
xmin = -1.5 - cx
xmax = 1.5 - cx
ymin = -1.5 - cy
ymax = 1.5 - cy

MaxIter = 64
Picture1.Cls

For iy = 0 To ny - 1
    Y = ymin + iy * (ymax - ymin) / (ny - 1)
    For ix = 0 To nx - 1
        If STOPNOW Then Exit Sub
        X = xmin + ix * (xmax - xmin) / (nx - 1)
        Color = VBJulia(cx, cy, X, Y, MaxIter)
        If Color = MaxIter Then
            Picture1.PSet (ix, iy), BLACK
        Else
            Picture1.PSet (ix, iy), LTGRAY
        End If
    Next
    DoEvents
Next
STOPNOW = True

End Sub

Function LoadPalette ()
Dim file As BITMAPFILEHEADER
Dim info As BITMAPINFOHEADER
Dim r As String * 1
Dim g As String * 1
Dim b As String * 1
Dim a As String * 1

LoadPalette = 0
Palettefile$ = App.Path + "\smooth.dib"
On Error GoTo NoPaletteFile
    Open Palettefile$ For Binary As #1
    Get #1, , file
    Get #1, , info

    If info.biBitCount <> 8 Then
        i = MsgBox("Not an 8-bit palette", 1)
    Else
        NColors = 256
        For i = 1 To NColors
            Get #1, , b
            Get #1, , g
            Get #1, , r
            Get #1, , a
            Palette(i, 1) = Asc(r)
            Palette(i, 2) = Asc(g)
            Palette(i, 3) = Asc(b)
        Next
    End If
    Close #1
    Picture1.Picture = LoadPicture(Palettefile$)
    Exit Function

NoPaletteFile:
    MsgBox "Couldn't open palette file"
    LoadPalette = -1
    Exit Function
    
End Function

Sub Mandel16Button_Click ()
Dim X As Double, Y As Double
Dim ix As Integer, iy As Integer
Dim MaxIter As Integer

STOPNOW = False
' Define picture resolution
nx = 256
ny = 256
' Select area of the complex plane to map on the screen
xmin = -1.5
xmax = .5
ymin = -1
ymax = 1
' Maximum number of iterations
MaxIter = 128

Picture1.Cls
For iy = 0 To ny - 1
     Y = (ymin + iy * (ymax - ymin) / (ny - 1))
     For ix = 0 To nx - 1
        If STOPNOW Then Exit Sub
        X = (xmin + ix * (xmax - xmin) / (nx - 1))
        M = VBMandel(X, Y, MaxIter)
        If M = MaxIter Then
            Picture1.PSet (ix, iy), BLACK
        Else
            Picture1.PSet (ix, iy), QBColor(M Mod 16)
        End If
     Next
    DoEvents
Next
STOPNOW = True
  
End Sub

Sub Mandel256Button_Click ()
Dim cx, cy As Double
Dim Color As Integer, CIndex As Integer
Dim ix As Integer, iy, MaxIter As Integer

If STOPNOW = True Then Exit Sub
i% = LoadPalette()
If i% < 0 Then Exit Sub

Rem Define picture resolution
nx = 256
ny = 256
Rem Select area of the complex plane to map on the screen
xmin = -1.5
xmax = .5
ymin = -1
ymax = 1
Rem Maximum number of iterations
MaxIter = 256

Rem for each point in the selected area  ...
For iy = 0 To ny - 1
     cy = (ymin + iy * (ymax - ymin) / (ny - 1))
     For ix = 0 To nx - 1
        If STOPNOW Then Exit Sub
        cx = (xmin + ix * (xmax - xmin) / (nx - 1))
        Color = VBMandel(cx, cy, MaxIter)
        CIndex = Color Mod 256
        Picture1.PSet (ix, iy), RGB(Palette(CIndex, 1), Palette(CIndex, 2), Palette(CIndex, 3))
     Next
    DoEvents
Next
STOPNOW = True

End Sub

Sub MandelBWButton_Click ()
Dim X As Double, Y As Double
Dim ix As Integer, iy As Integer
Dim nx As Integer, ny As Integer
Dim MaxIter As Integer


STOPNOW = False
' Define picture resolution
nx = 256
ny = 256
' Select area of the complex plane to map on the screen
xmin = -1.5
xmax = .5
ymin = -1
ymax = 1
' Maximum number of iterations
MaxIter = 32
Picture1.Cls

' for each point in the selected area  ...
    For iy = 0 To ny - 1
        Y = (ymin + iy * (ymax - ymin) / (ny - 1))
        For ix = 0 To nx - 1
            If STOPNOW Then Exit Sub
            X = (xmin + ix * (xmax - xmin) / (nx - 1))
' ... check whether it escapes to infinity or not
            M = VBMandel(X, Y, MaxIter)
            If M = MaxIter Then
                Picture1.PSet (ix, iy), BLACK
            Else
                Picture1.PSet (ix, iy), LTGRAY
            End If
        Next
        DoEvents
    Next
    STOPNOW = True
End Sub

Function VBJulia (ByVal cx As Double, ByVal cy As Double, ByVal X As Double, ByVal Y As Double, ByVal MaxIter As Integer) As Integer
Dim iter As Integer
Dim x2 As Double, y2 As Double
Dim xtemp As Double, ytemp As Double
    
    iter = 0
    x2 = X + cx
    y2 = Y + cy
    While ((iter < MaxIter) And (Abs(x2) + Abs(y2) < 100000))
        xtemp = x2 * x2 - y2 * y2 + cx
        ytemp = 2 * x2 * y2 + cy
        x2 = xtemp
        y2 = ytemp
        iter = iter + 1
    Wend
    VBJulia = iter

End Function

Function VBMandel (ByVal cx As Double, ByVal cy As Double, ByVal MaxIter As Integer) As Integer
Dim x2 As Double, y2 As Double
Dim temp As Double
Dim X As Double, Y As Double

X = 0
Y = 0
x2 = 0
y2 = 0
iter = 0

While ((iter < MaxIter) And (Abs(x2) + Abs(y2) < 100000))
    temp = x2 - y2 + cx
    Y = 2 * X * Y + cy
    X = temp
    x2 = X * X
    y2 = Y * Y
    iter = iter + 1
Wend
VBMandel = iter


End Function

