VERSION 2.00
Begin Form FractalForm 
   Caption         =   "Form2"
   ClientHeight    =   1995
   ClientLeft      =   1230
   ClientTop       =   2385
   ClientWidth     =   1995
   ForeColor       =   &H000000FF&
   Height          =   2400
   Left            =   1170
   LinkTopic       =   "Form2"
   MDIChild        =   -1  'True
   ScaleHeight     =   133
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   133
   Top             =   2040
   Visible         =   0   'False
   Width           =   2115
End

Sub Form_Activate ()
    
    If NOWDRAWING Then
        Exit Sub
    End If

    CurrentFractal = Val(Me.Tag)

End Sub

Sub Form_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If NOWDRAWING Then
        Beep
        Exit Sub
    End If
   If Button And 1 Then
        Me.DrawMode = 7   'XOR PEN
Rem The next few lines center the box at (X, Y)
        XSide = Me.ScaleWidth / ZoomFactor
        YSide = Me.ScaleHeight / ZoomFactor
        Line (X - .5 * XSide, Y - .5 * YSide)-(X + .5 * XSide, Y + .5 * YSide), , B
        XOld = X
        YOld = Y
    End If

End Sub

Sub Form_MouseMove (Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If NOWDRAWING Or Me.DrawMode <> 7 Then
        Exit Sub
    End If

    If Button And 1 Then
        XSide = Me.ScaleWidth / ZoomFactor
        YSide = Me.ScaleHeight / ZoomFactor
        Line (XOld - .5 * XSide, YOld - .5 * YSide)-(XOld + .5 * (Me.ScaleWidth / ZoomFactor), YOld + .5 * (Me.ScaleHeight / ZoomFactor)), , B
        Line (X - .5 * (Me.ScaleWidth / ZoomFactor), Y - .5 * (Me.ScaleHeight / ZoomFactor))-(X + .5 * (Me.ScaleWidth / ZoomFactor), Y + .5 * (Me.ScaleHeight / ZoomFactor)), , B
        XOld = X
        YOld = Y
    End If

End Sub

Sub Form_MouseUp (Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim DeltaX, DeltaY As Double

    If NOWDRAWING Or Me.DrawMode <> 7 Then
        Exit Sub
    End If

    Line (X - .5 * (Me.ScaleWidth / ZoomFactor), Y - .5 * (Me.ScaleHeight / ZoomFactor))-(X + .5 * (Me.ScaleWidth / ZoomFactor), Y + .5 * (Me.ScaleHeight / ZoomFactor)), , B
    Me.DrawMode = 13

    DeltaX = FractalXY(Me.Tag, 2) - FractalXY(Me.Tag, 1)
    DeltaY = FractalXY(Me.Tag, 4) - FractalXY(Me.Tag, 3)

    XMin = FractalXY(Me.Tag, 1) + X * DeltaX / Me.ScaleWidth - (DeltaX / ZoomFactor) / 2
    YMin = FractalXY(Me.Tag, 3) + Y * DeltaY / Me.ScaleHeight - (DeltaY / ZoomFactor) / 2
    XMax = FractalXY(Me.Tag, 1) + X * DeltaX / Me.ScaleWidth + (DeltaX / ZoomFactor) / 2
    YMax = FractalXY(Me.Tag, 3) + Y * DeltaY / Me.ScaleHeight + (DeltaY / ZoomFactor) / 2
    CancelDraw = False
    'Form1!Command3D1_Click

End Sub

Sub Form_Resize ()

    If Fractals(CurrentFractal).WindowState = 1 Then
        CancelDraw = True
    End If

End Sub

Sub Form_Unload (Cancel As Integer)

    If CurrentFractal = Me.Tag Then
        Beep
        CancelDraw = True
        DRAWINGNOW = False
        DoEvents
    End If

End Sub

